function obj=curr(X,X_label)
% the linear combination of multiview nonlinear projection
% d: the number of low dimensionality space features
% r: adjustment factor
% beta,gamma: trade-off factor
% X: different view samples
% Y: projection samples
% alpha: linear combination coefficient
d=50;
r=2;
beta=1;
gamma=2;
lambda=2^(-5);
k=3;
t=10^4;
v=size(X,2);%multiviews
n=size(X{1},1);
alpha=ones(v,1)/v;
W=quanzhong2(X,k,t);
for i=1:v
    M{i}=tr(X{i},W{i},gamma,lambda,X_label);
end
Hn=eye(n)-ones(n)/n;
%%%MM=zeros(n);%%%
for i=1:10%iteration
%    tic
    MM=zeros(n);
    for j=1:v
        MM=MM+(alpha(j)^r)*M{j};
    end
%    [vec,val]=eig(MM,Hn);
    [vec,val]=eig((Hn+0.0001*eye(n))\MM);%
    [~,ind]=sort(diag(val));
    sind=ind(1:d);
    Y=(vec(:,sind))';
    obj(i)=trace(Y*MM*Y');%objective function
    for j=1:v
        trc(j)=trace(Y*M{j}*Y');
        a(j)=(1/trc(j))^(1/(r-1));
    end
    b=sum(a);
    alpha=a/b;
%    toc
end
save curr obj
 
%-----subfunction-----%
function M=tr(X,W,gamma,lambda,label)
[n,m]=size(X);
Im=eye(m);
In=eye(n);
V=In-X/((X'*X)+gamma*Im)*X';
U=tr_U(X,label);
d=sum(W,2);
D=diag(d);
M=U+V/2+lambda*(D-W);

%-----sub_subfunction-----%
function U=tr_U(train,train_label)%,dim) 
n=size(train,1);
UY=unique(train_label);
U=zeros(n);
c=length(UY);
for i=1:c
    class=find(train_label==UY(i));
    nc=length(class);
    ind_mat=zeros(n,nc);    
    for j=1:nc
        ind_mat(class(j),j)=1;
    end
    u=ind_mat*(eye(nc)-ones(nc)/nc)*ind_mat';
    U=U+u;
end

function W=quanzhong2(Xtrain,k,t)
v=size(Xtrain,2);
n=size(Xtrain{1},1);
for i=1:v
    for j=1:n
    e{i}{j} =KNN(Xtrain{i}(j,:),Xtrain{i},k);
    end
end
for j=1:n
    for i=1:(v-1)
        f{j}=intersect(e{i}{j},e{i+1}{j});
    end
end
for d=1:v
    a=zeros(n,n);
    W{d}=a;
    for i=1:n
        for j=1:length(f{i})
            W{d}(i,f{i}(j))=exp(-(norm(Xtrain{d}(i,:)-Xtrain{d}(f{i}(j),:))^2)/t);
            W{d}(f{i}(j),i)=exp(-(norm(Xtrain{d}(i,:)-Xtrain{d}(f{i}(j),:))^2)/t);
        end
    end
end

function [e] =KNN(in,test,k)
dist=zeros(size(test,1),1);
for i=1:size(test,1)
     dist(i)=norm(in-test(i,:),2);
end   
[sdist,index]=sort(dist);
e=index(2:k+1);
