function [alpha,PT]=pro_multiDA(d,r,beta,gamma,X,X_label)
% the linear combination of multiview nonlinear projection
% d: the number of low dimensionality space features
% r: adjustment factor
% beta,gamma: trade-off factor
% X: different view samples
% Y: projection samples
% alpha: linear combination coefficient
v=size(X,2);%multiviews
n=size(X{1},1);
alpha=ones(v,1)/v;
for i=1:v
    M{i}=tr(X{i},beta,gamma,X_label);
end
Hn=eye(n)-ones(n)/n;
%%%MM=zeros(n);%%%
for i=1:50%iteration
%    tic
    MM=zeros(n);
    
    
    for j=1:v
        MM=MM+(alpha(j)^r)*M{j};
    end
%    [vec,val]=eig(MM,Hn);
    [vec,val]=eig((Hn+0.0001*eye(n))\MM);%
    [~,ind]=sort(diag(val));
    sind=ind(1:d);
    Y=(vec(:,sind))';
    obj(i)=trace(Y*MM*Y');%objective function
    if i==7%%%
        break;
    end
    for j=1:v
        trc(j)=trace(Y*M{j}*Y');
        a(j)=(1/trc(j))^(1/(r-1));
    end
    b=sum(a);
    alpha=a/b;
%    toc
end
Y=real(Y);
for i=1:v
    m=size(X{i},2);
    Im=eye(m);
    PT{i}=(beta*Y*X{i})/(beta*(X{i}'*X{i})+gamma*Im);
end
 
%-----subfunction-----%
function M=tr(X,beta,gamma,label)
[n,m]=size(X);
Im=eye(m);
In=eye(n);
V=In-X/(beta*(X'*X)+gamma*Im)*X';
U=tr_U(X,label);
M=U+V*(beta^3)/2;

%-----sub_subfunction-----%
function U=tr_U(train,train_label)%,dim) 
n=size(train,1);
UY=unique(train_label);
U=zeros(n);
c=length(UY);
for i=1:c
    class=find(train_label==UY(i));
    nc=length(class);
    ind_mat=zeros(n,nc);    
    for j=1:nc
        ind_mat(class(j),j)=1;
    end
    u=ind_mat*(eye(nc)-ones(nc)/nc)*ind_mat';
    U=U+u;
end
