function obj=curr(X,X_label)
% the linear combination of multiview nonlinear projection
% d: the number of low dimensionality space features
% r: adjustment factor
% beta,gamma: trade-off factor
% X: different view samples
% Y: projection samples
% alpha: linear combination coefficient
d=50;
r=2;
beta=1;
gamma=0.5;
lambda=2^(3);
k=3;
t=10^4;

v=size(X,2);%multiviews
n=size(X{1},1);
alpha=ones(v,1)/v;
for i=1:v
    dim(i)=size(X{i},2);
    P{i}=ones(dim(i),d);
end
DA=quanzhong2(X,k,t);
for i=1:v
    W{i}=zeros(size(P{i},1),size(P{i},1));
    for a1=1:size(P{i},1)
        a=2*norm(P{i}(a1,:));
        if a==0                    
            W{i}(a1,a1)=0;
        else
            W{i}(a1,a1)=1/a;
        end
    end
end
Hn=eye(n)-ones(n)/n;
%%%MM=zeros(n);%%%
for i=1:10%iteration
%    tic
    for ii=1:v
        [M{ii},G{ii}]=tr(X{ii},W{ii},DA{ii},alpha(ii),gamma,lambda,X_label);
    end
    MM=zeros(n);
    for j=1:v
        MM=MM+M{j};
    end
%    [vec,val]=eig(MM,Hn);
    [vec,val]=eig((Hn+0.0001*eye(n))\MM);%
    [~,ind]=sort(diag(val));
    sind=ind(1:d);
    Y=(vec(:,sind))';
    for j=1:v
        trc(j)=trace(Y*G{j}*Y'+P{j}'*W{j}*P{j});
        a(j)=(1/trc(j))^(1/(r-1));
    end
    b=sum(a);
    alpha=a/b;
    obj(i)=sum(trc(j));
    for ii=1:v
        P{ii}=(Y*X{ii}*((X{ii}'*X{ii})+1/2*gamma*W{ii})^(-1))';
        if (numel(find(isnan(P{ii})))>0)
            P{ii}=(Y*X{ii}*((X{ii}'*X{ii})+1/2*gamma*W{ii}+0.0001*eye(size(W{ii},1)))^(-1))';
            %P{ii}=(Y*X{ii}*pinv((X{ii}'*X{ii})+1/2*gamma*W{ii}))';
        end
        for a1=1:size(P{ii},1)
            aa=2*norm(P{ii}(a1,:));
            if aa==0                    
                W{ii}(a1,a1)=0;
            else
                W{ii}(a1,a1)=1/aa;
            end
        end
    end
end
save curr obj;
 
%-----subfunction-----%
function [M,G]=tr(X,W,DA,alpha,gamma,lambda,label)
[n,m]=size(X);
Im=eye(m);
In=eye(n);
L=tr_U(X,label);
%V=In-X/((X'*X)+gamma*Im)*X';
U=((X'*X)+1/2*gamma*W)^(-1);
if (numel(find(isnan(U)))>0)
    U=((X'*X)+1/2*gamma*W+0.0001*Im)^(-1);
    %U=pinv((X'*X)+1/2*gamma*W+0.0001*Im);
end
G=X*(U*X'*X*U'-U-U')*X'+In+L;
d=sum(DA,2);
D=diag(d);
M=alpha^2*(G+lambda*(D-DA));

%-----sub_subfunction-----%
function U=tr_U(train,train_label)%,dim) 
n=size(train,1);
UY=unique(train_label);
U=zeros(n);
c=length(UY);
for i=1:c
    class=find(train_label==UY(i));
    nc=length(class);
    ind_mat=zeros(n,nc);    
    for j=1:nc
        ind_mat(class(j),j)=1;
    end
    u=ind_mat*(eye(nc)-ones(nc)/nc)*ind_mat';
    U=U+u;
end

function W=quanzhong2(Xtrain,k,t)
v=size(Xtrain,2);
n=size(Xtrain{1},1);
for i=1:v
    for j=1:n
    e{i}{j} =KNN(Xtrain{i}(j,:),Xtrain{i},k);
    end
end
for j=1:n
    for i=1:(v-1)
        f{j}=intersect(e{i}{j},e{i+1}{j});
    end
end
for d=1:v
    a=zeros(n,n);
    W{d}=a;
    for i=1:n
        for j=1:length(f{i})
            W{d}(i,f{i}(j))=exp(-(norm(Xtrain{d}(i,:)-Xtrain{d}(f{i}(j),:))^2)/t);
            W{d}(f{i}(j),i)=exp(-(norm(Xtrain{d}(i,:)-Xtrain{d}(f{i}(j),:))^2)/t);
        end
    end
end

function [e] =KNN(in,test,k)
dist=zeros(size(test,1),1);
for i=1:size(test,1)
     dist(i)=norm(in-test(i,:),2);
end   
[sdist,index]=sort(dist);
e=index(2:k+1);

